
import g4p_controls.*;
import processing.serial.*;
import java.io.File;
import java.util.Calendar;
import java.util.TimeZone;
import java.util.Locale;

Calendar calender;

/********************* STANDORT ******************************/
boolean RECHNER = false;
boolean LAPTOP = false;
boolean OBSERVATORIUM = true;
/*************************************************************/

PImage a;
Serial AntennaSerial;
Serial ObservSerial;
Serial BluetoothSerial;
boolean SerialOnline;
boolean standalone = false;
int linefeed = 10; 
PrintWriter motorlog;
boolean motorlog_created = false;

String stringAZALT = null;
float lastAZ = 270.34;
float lastALT = 40.594444;
float lastTEMP = 0.0;
float lastHIGH = 0.0;
float lastROLL = 3.0;
float lastPITCH = 10.8;
boolean lastUP = false;
boolean lastDOWN = false;
float lastOFFSET = 30.0;
int numSensors = 10;  // we will be expecting for reading data from four sensors
float sensors[];       // array to read the 4 values
float pSensors[];   
int last_g = 30;  //ALT ej. 48° 30' 28''
int last_m = 30;
int last_s = 30;
int last_az_h = 4;  //AZ ej. 13h 20' 14''
int last_az_m = 20;
int last_az_s = 10;

int WISHED_ANGLE = 0;
int MOTOR_DOWN = 1;
int MOTOR_UP = 2;
int MOTOR_STOP = 3;
boolean last_sent_motorONOFF = true;
boolean motor_on_online = false;

//after starting we will shutdown the motor. Untill this variable does not become true
//we should not create a writer for ALT AZ or Read from Arduinto ALT AZ
//because we want to keep the last wrotten alt_az.txt file and read it for
//initiaization of the buttont and sliders. 
boolean do_1_after_arduino_alive = false;  

PGraphics cp5;

boolean waiting_for_send = false;
float wished_alt_tosend = -1;
long time_of_motor_start = -1;
long time_of_mess_sent = -1;
int TIME_TO_WAIT_FOR_MOTOR = 30;
String gnuplot_dir;
String dropbox_dir;
String main_dir;
String scanner_dir;
String MOTOR_COM_PORT;
String RADIOT_COM_PORT;
String BT_COM_PORT;
String alt_az_filename="az_alt.txt";
String online_alt_filename;
String switch_on_filename;
String motor_on_filename;
String motor_off_filename;



GCustomSlider sdr1, sdr2, sdr3, sdr4, sdr5, sdrG, sdrM, sdrS;
GKnob kbHeading, kbAltitud, kbPitch, kbRoll, kbOffset;
GSlider sdSpeed;
GImageToggleButton btUp, btDown, btONOFF, btLogger, btOut;
GButton btStop, btSend;
GLabel lbHeadingText, lbSpeed, lbUp, lbDown, lbStop, lbSend, lbPitch, lbRoll, lbOffset;
GLabel lnMotor, lbLogger;
int bgcol = 128;


/***********************************************************************************************/
/***********************************   Radio Telescope Declarations ****************************/
/***********************************************************************************************/
PrintWriter RadioTLog;
BufferedReader reader;
String line;
PrintWriter file_end;
PrintWriter log_info;
int MODE_BASELINE = 0;
int MODE_TOTAL_POWER = 1;
int mode = MODE_TOTAL_POWER;

int numRTSensors = 12; // we will be expecting for reading data from four rt_sensors
float rt_sensors[];       // array to read the 4 values
float pRTSensors[];   
int minutes_per_file = 5;
int last_minute_logged = -1;
int last_hour_logged = -1;
int last_day_logged = -1;
boolean start_writting = false;
int ignore_num = 6;
String last_file_created;

Stripchart s1;
Stripchart s2;
Stripchart s3;
Stripchart s_mag;
int n = 0;
//PFont f; 
int s3_fields = 9;
int s2_fields = 2;
int s1_fields = 3;
int s_mag_fields = 3;

String last_scan_time;
int watch_stick_zycle = 10000;
int watch_stick_iter = watch_stick_zycle;

//Temperature Compensation
String baseline_file_name = "Baseline.txt";
String block_while_writting = "FileBlocked.info";
float last_baseline_done = 1.0;
int time_last_baseline = 0;
double time_offset_ok = 600;
//float baseline_offset = 0.067;
float baseline_offset = 0.01;
float baseline_offset_ok = 0.6;
float last_baseline_received = 0.0;

float last_total_power_sent = -1.0;

int read_baseline_iter = 200;
int cnt_read_baseline = read_baseline_iter;

int BASELINE_MESSURES = 20;
int cnt_baseline_messure = 0;
//float baseline_mess[20];
float[] baseline_mess = new float[BASELINE_MESSURES];
boolean no_data_alarm = false;





int mywindows_width = 1140;
int mywindows_height = 660;
int antenne_x = 165;
int antenne_y = 530;
int trans_y_mast = 600;
int trans_x_mast = 155;

int stripchar_text_x = 1060;

PFont f; 



void setup() {
  //size(600, 280);
  //size(1300, 900, P2D);
  size(mywindows_width, mywindows_height, P3D);
  
  a = loadImage("antenna_B.gif");

  if( RECHNER == true )
  {
    gnuplot_dir="D:\\Programme\\Entwicklung\\Grafik\\gp442win32\\gnuplot\\binary\\";
    main_dir="F:\\RealViewProjects\\";
    scanner_dir="F:\\RTLSDR-Scanner\\";
    MOTOR_COM_PORT="COM4";
    RADIOT_COM_PORT="COM13";
    online_alt_filename="SetALT_test.txt";
    switch_on_filename="SwitchOnOff_test.txt";
    motor_on_filename="MotorOn_test.info";
    motor_off_filename="MotorOff_test.info";       
  }
  else if(LAPTOP == true)
  {
    gnuplot_dir="D:\\Programme\\Entwicklung\\Grafik\\gp442win32\\gnuplot\\binary\\";
    main_dir="D:\\Radioteleskop-Logs\\RealViewProjects\\";
    scanner_dir="D:\\Radioteleskop-Logs\\RTLSDR-Scanner\\";
    dropbox_dir="C:\\Users\\MJesus3\\Dropbox\\Radioteleskop-ONLINE\\";
    MOTOR_COM_PORT="COM4";
    RADIOT_COM_PORT="COM13";
    dropbox_dir="C:\\Users\\MJesus3\\Dropbox\\Radioteleskop-ONLINE\\";
    online_alt_filename="SetALT_test.txt";
    switch_on_filename="SwitchOnOff_test.txt";
    motor_on_filename="MotorOn_test.info";
    motor_off_filename="MotorOff_test.info";   
  }
  else if(OBSERVATORIUM == true)
  {
    main_dir="F:\\RealViewProjects\\dayfiles\\";
    gnuplot_dir="F:\\Grafik\\gp442win32\\gnuplot\\binary\\";
    scanner_dir="F:\\RTLSDR-Scanner\\";
    MOTOR_COM_PORT="COM1"; //RF PORT
//String MOTOR_COM_PORT="COM9";
    RADIOT_COM_PORT="COM4";
    dropbox_dir="D:\\Dropbox\\Radioteleskop-ONLINE\\";
    BT_COM_PORT="COM9";
    alt_az_filename="az_alt.txt";
    online_alt_filename="SetALT.txt";
    switch_on_filename="SwitchOnOff.txt";
    motor_on_filename="MotorOn.info";
    motor_off_filename="MotorOff.info";
   
  }

  //f = createFont("Arial",12,true);
  //textFont(f,12); 
/**********************************************/
/*              Serial Ports                  */
/**********************************************/
  if( standalone == false )
  {
    int PortNumber=0;
    int PortCount = Serial.list().length;    
    SerialOnline = false;
    String str1 = MOTOR_COM_PORT;       // Can change to be the name of the port you want, e.g., COM5.
    String str2; 
    int j = 0;
   
    /********************************************************************************/
    /****************    Activate MOTOR CONTROLLING PORT   **************************/
    /********************************************************************************/    
    while (j < (PortCount ))
    {
      int check = Serial.list()[j].length();
      str2 = Serial.list()[j].substring(0, Serial.list()[j].length());
      if (str1.equals(str2)) 
      {
        PortNumber = j;
      }
      j++; 
    } 
    if (PortNumber >= 0)
    { 
      String portName = Serial.list()[PortNumber];
      AntennaSerial = new Serial(this, portName, 9600);
      AntennaSerial.bufferUntil(linefeed);
      AntennaSerial.clear(); 
      println("MOTOR Serial port "+Serial.list()[PortNumber]+" found and activated.");
      SerialOnline = true;
    } 
    else
    {
      println("\nI found "+PortCount+" serial ports, which are:");
      println(Serial.list());
      println("But I don't know which one to use. :(\n"); 
      println("Now entering offline simulation mode.\n");    
    }
 
    /*********************************************************************************/
    /****************    Activate RADIOT CONTROLLING PORT   **************************/
    /*********************************************************************************/
    PortNumber=0;
    PortCount = Serial.list().length;    
    SerialOnline = false;    
    str1 = RADIOT_COM_PORT; 
    str2=""; 
    j = 0;
    
    while (j < (PortCount ))
    {
      int check = Serial.list()[j].length();
      str2 = Serial.list()[j].substring(0, Serial.list()[j].length());
      if (str1.equals(str2)) 
      {
        PortNumber = j;
      }
      j++; 
    } 
    if (PortNumber >= 0)
    { 
      String portName = Serial.list()[PortNumber];
      ObservSerial = new Serial(this, portName, 9600);
      ObservSerial.bufferUntil(linefeed);
      ObservSerial.clear(); 
      println("RADIO TELESCOPE Serial port "+Serial.list()[PortNumber]+" found and activated.");
      SerialOnline = true;
    } 
    else
    {
      println("\nI found "+PortCount+" serial ports, which are:");
      println(Serial.list());
      println("But I don't know which one to use. :(\n"); 
      println("Now entering offline simulation mode.\n");    
    }   
     
  }
  else
  {
    println("Using in Standalone Mode");
    do_1_after_arduino_alive = true;
  }

  background(200, 200, 255);
  fill(0); 
  
    fill(0,128, 255);                        // STEP 5 Specify font color 
  text("AD8362",stripchar_text_x-100,40);  
  text("AD8362",stripchar_text_x-100,380);    
  fill(209,5,194);                        // STEP 5 Specify font color 
  text("DC_AMP",stripchar_text_x-100,60);  
  fill(2,138,50);                        // STEP 5 Specify font color 
  text("TEMP °C",stripchar_text_x-100,80);  
  fill(1,82,30);                        // STEP 5 Specify font color 
  text("LM35",stripchar_text_x-100,100);  
  fill(220, 155, 0);                        // STEP 5 Specify font color 
  text("AMPL-AD8331",stripchar_text_x-100,120);  
  //fill(98, 176, 255);                        // STEP 5 Specify font color 
  fill(61, 233, 3);
  text("TOTALPOWER",stripchar_text_x-100,140);  
  text("TOTALPOWER",stripchar_text_x-100,400);    
  fill(239, 0, 25);                        // STEP 5 Specify font color 
  text("CompPos",stripchar_text_x-100,160);  
  text("CompPos",stripchar_text_x-100,275);  
  fill(100, 15, 100);                        // STEP 5 Specify font color 
  text("CompNeg",stripchar_text_x-100,180);  
  text("CompNeg",stripchar_text_x-100,295);    
  fill(100, 235, 245);                        // STEP 5 Specify font color 
  text("AD4725_read",stripchar_text_x-100,200);  
  text("AD4725_read",stripchar_text_x-100,315);      
  fill(0);                        // STEP 5 Specify font color 
  text("Baseline",stripchar_text_x-100,230);
  fill(0,128, 255);
  text("MAGNETO X", stripchar_text_x-100,470);
  fill(209,5,194);
  text("MAGNETO Y", stripchar_text_x-100,490);
  fill(2,138,50);
  text("MAGNETO Z", stripchar_text_x-100,510);

/**********************************************/
/*                    Slider                  */
/**********************************************/
  sdrG = new GCustomSlider(this,20,1, 260, 80, null);
  // show          opaque  ticks value limits
  sdrG.setShowDecor(false, true, true, true);
  sdrG.setNumberFormat(G4P.DECIMAL, 1);
  sdrG.setLimits(0, 10, 90);
  sdrG.setNbrTicks(16); 
  sdrG.setEasing(15);
  sdrG.setStickToTicks(true);
  text("Grad",290,50);      
 
  
  sdrM = new GCustomSlider(this,20,51, 260, 80, null);
  // show          opaque  ticks value limits
  sdrM.setShowDecor(false, true, true, true);
  sdrM.setNumberFormat(G4P.DECIMAL, 1);
  sdrM.setLimits(0, 10, 60);
  sdrM.setNbrTicks(16); 
  sdrM.setEasing(15);
  sdrM.setStickToTicks(true);    
  

  sdrS = new GCustomSlider(this,20,101, 260, 80, null);
  // show          opaque  ticks value limits
  sdrS.setShowDecor(false, true, true, true);
  sdrS.setNumberFormat(G4P.DECIMAL, 1);
  sdrS.setLimits(0, 10, 60);
  sdrS.setNbrTicks(16); 
  sdrS.setEasing(15);
  sdrS.setStickToTicks(true);    
  
  sdSpeed = new GSlider(this, 100, 200, 120, 40, 12);
  sdSpeed.setShowDecor(false, false, true, false);
  sdSpeed.setLimits(0, 0, 255);
  sdSpeed.setValue(200);
  lbSpeed = new GLabel(this, 110, 220, 100, 40, "Motor Speed");
  
  println("SLIDERS DONE");
  
/**********************************************/
/*                   Knobs                    */
/**********************************************/
  G4P.setCursorOff(CROSS);
  // Create the knob using default settings
  kbHeading = new GKnob(this, 20, 360, 130, 130, 0.8f);
  kbHeading.setTurnRange(-90, 270);
  kbHeading.setLimits(90, 0, 360);
  kbHeading.setTurnMode(G4P.CTRL_ANGULAR);
  kbHeading.setNbrTicks(60);
  
  kbAltitud = new GKnob(this, 160, 360, 130, 130, 0.8f);
  kbAltitud.setTurnRange(-90, 270);
  kbAltitud.setNbrTicks(60);
  
  kbOffset = new GKnob(this, 320, 390, 70, 70, 0.8f);
  kbOffset.setTurnRange(-90, 270);
  lbOffset = new GLabel(this, 305, 340, 100, 40, "Offset");
 
  kbRoll = new GKnob(this, 270, 490, 80, 80, 0.8f);
  kbRoll.setTurnRange(-90, 270);
  lbRoll = new GLabel(this, 200, 505, 100, 40, "ROLL");
 
  kbPitch = new GKnob(this, 270, 580, 80, 80, 0.8f);
  kbPitch.setTurnRange(-90, 270);
  lbPitch = new GLabel(this, 200, 600, 100, 40, "PITCH");
  
  println("KNOB DONE");
/**********************************************/
/*                   Buttons                  */
/**********************************************/  
  btUp = new GImageToggleButton(this, 50, 200);
  btUp.tag = "Up";
  //btUp.stateValue(0);
  lbUp = new GLabel(this, 20, 130, 100, 110, "Motor Up");
  btDown = new GImageToggleButton(this, 240, 200);
  btDown.tag = "Down";
  //btDown.stateValue(0);
  lbDown = new GLabel(this, 210, 130, 100, 110, "Motor Down");
  
  btStop = new GButton(this, 120, 270, 20, 20);
  btStop.tag = "Stop";
  lbStop = new GLabel(this, 80, 240, 100, 110, "Stop");
  
  btSend = new GButton(this, 180, 270, 20, 20);
  btSend.tag = "Send";  
  lbSend = new GLabel(this, 140, 240, 100, 110, "Send");
  
  btONOFF = new GImageToggleButton(this, 350, 20);
  btONOFF.tag = "onoff";
  //DeactivateMotor( );
  btONOFF.stateValue( 1 );
  //SendPleaseMotorControl( false );  
  
  btLogger= new GImageToggleButton(this, 350, 120);
  btLogger.tag = "logger";
  btLogger.stateValue( 1 );

  btOut= new GImageToggleButton(this, 350, 220);
  btOut.tag = "conn_out";
  btOut.stateValue( 1 );  
  
  println("BUTTONS DONE");
  
/**********************************************/
/*                   Chart Logger             */
/**********************************************/  
  s3 = new Stripchart(440, 10, 450, 200, 45, 0.0, 7.0, s3_fields);
  s3.setChannel(0, color(0,128, 255));
  s3.setChannel(1, color(209,5,194));
  s3.setChannel(2, color(2,138,50));
  s3.setChannel(3, color(1,82,30));
  s3.setChannel(4, color(220, 155, 0));
  //s3.setChannel(5, color(98, 176, 255));
  s3.setChannel(5, color(61, 233, 3));
  s3.setChannel(6, color(239, 0, 25));  
  s3.setChannel(7, color(100, 15, 100));  
  s3.setChannel(8, color(100, 235, 245));    

  s1 = new Stripchart(440, 220, 445, 100, 45, 0.0, 1.0, s1_fields);
  s1.setChannel(0, color(239, 0, 25));  
  s1.setChannel(1, color(100, 15, 100));    
  s1.setChannel(2, color(100, 235, 245));  //canal 2

  s2 = new Stripchart(440, 330, 445, 100, 45, 0.0, 4.5, s2_fields);
  s2.setChannel(0, color(61, 233, 3));  //canal 0
  //s2.setChannel(1, color(98, 176, 255));  //canal 1   61, 233, 3 
  s2.setChannel(1, color(0,128, 255));  //canal 1
  

  s_mag = new Stripchart(440, 440, 440, 100, 45, 0.0, 1400.0, s_mag_fields);
  s_mag.setChannel(0, color(0,128, 255));  
  s_mag.setChannel(1, color(209,5,194));    
  s_mag.setChannel(2, color(2,138,50));    
  
  frameRate(40); 
  
  println("STRIPCHART LOGGER DONE");
  
/**********************************************/
/*                   LogFiles                 */
/**********************************************/  

  int d = last_day_logged = day();    // Values from 1 - 31
  int m = month();  // Values from 1 - 12
  int y = year();   // 2003, 2004, 2005, etc.
  int h = last_hour_logged = hour();    // Values from 1 - 31
  int mi = last_minute_logged = minute();  // Values from 1 - 12
  int se = second();   // 2003, 2004, 2005, etc.
  String d_mod = (( d < 10)?"0":"") + String.valueOf(d);        
  String m_mod = (( m < 10)?"0":"") + String.valueOf(m); //String.valueOf(m)                
  String h_mod = (( h < 10)?"0":"") + String.valueOf(h);        
  String mi_mod = (( mi < 10)?"0":"") + String.valueOf(mi);       
  String se_mod = (( se < 10)?"0":"") + String.valueOf(se);      
  RadioTLog = createWriter( main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt");
  last_file_created =  main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt";
  
  log_info = createWriter( main_dir + "LogInfoLogDet_" + d_mod + "." + m_mod + "." + String.valueOf(y) + ".txt");
  
  ResetBaselineValues();  
  for(int b_index=0;b_index<BASELINE_MESSURES;b_index++)
  {
    baseline_mess[b_index] = 1000;
  }        
    
  ReadAntennePosition();
  
  
  println("SETUP DONE");
}

void draw() 
{  
  
  //background(200, 200, 255);
  //stroke(204, 102, 0);
  fill(200, 200, 255);
  rect(1, 1, 420, 660);

    
  fill(0);
  //textSize(14); 
  text("Grad",290,45);
  text("Min",290,95);  
  text("Sec",290,145);
  text("HEADING",62,325);
  text("N",82,357);  
  text("S",85,500);
  text("W",7,425);  
  text("E",150,425);
  String conv_az=ConvertFloatToGrad(lastAZ, false);  
  text(conv_az,50,340);
  kbHeading.setLimits(lastAZ, 0, 360);
  text("90°",215,357);
  text("0°",290,425);
  String conv_alt;
  conv_alt = ConvertFloatToGrad(lastALT, true );
  text(conv_alt,190,340);
  text("ALTITUD",200,325);
  text( "Motor ON", 350, 15);
  text( "Motor OFF", 350, 85);
  text( "Logger ON", 350, 115);
  text( "Logger OFF", 350, 185);
  
  text( "Serial OUT", 350, 215);
  
  
  
  kbAltitud.setLimits(90.0-lastALT, 0, 360);

  kbPitch.setLimits(90.0-lastPITCH, 0, 360);
  String conv_pit=ConvertFloatToGrad(lastPITCH, false);  
  text(conv_pit,285, 580);  
  
  kbRoll.setLimits(90.0-lastROLL, 0, 360);
  String conv_roll=ConvertFloatToGrad(lastROLL, false);  
  text(conv_roll,290, 490);  
  
  //OFFSET
  kbOffset.setLimits(90.0-lastOFFSET, 0, 360);
  String conv_off=ConvertFloatToGrad(lastOFFSET, false);  
  text(conv_off,330, 385);  
  
        
  if( btONOFF.stateValue() == 1 && do_1_after_arduino_alive == true )
  {    
    if( motorlog_created == false )
    {
     log_info.println( WriteTimeStr() + "Creating ALTAZ text file"); 
      motorlog = createWriter( gnuplot_dir + alt_az_filename );
      motorlog_created = true;
    }
    GetComData();
  }
      
  
  int d  = day();    // Values from 1 - 31
  int h  = hour();    // Values from 1 - 31
  int mi = minute();  // Values from 1 - 12
  int m = month();  // Values from 1 - 12
  int y = year();   // 2003, 2004, 2005, etc.
  int se = second();   // 2003, 2004, 2005, etc.  
  
  String d_mod = (( d < 10)?"0":"") + String.valueOf(d);        
  String m_mod = (( m < 10)?"0":"") + String.valueOf(m); //String.valueOf(m)                
  String h_mod = (( h < 10)?"0":"") + String.valueOf(h);        
  String mi_mod = (( mi < 10)?"0":"") + String.valueOf(mi);       
  String se_mod = (( se < 10)?"0":"") + String.valueOf(se);    
  
  File f_tmp = new File(main_dir + "LogInfoLogDet_" + d_mod + "." + m_mod + "." + String.valueOf(y) + ".txt");
  if( !f_tmp.exists() )
  {
    log_info.close();
    log_info = createWriter( main_dir + "LogInfoLogDet_" + d_mod + "." + m_mod + "." + String.valueOf(y) + ".txt");
  }
  else
    log_info.flush();
  
  
  boolean changed = false;
  String new_file_created = last_file_created;
  if( last_day_logged == d )
  {
    if( last_hour_logged == h )
    {
      if( (mi - last_minute_logged) > minutes_per_file )
      {
        RadioTLog.close();
        RadioTLog = createWriter( main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt");    
        new_file_created =  main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt";     
        changed = true;
      }
    }
    else if( (60 - last_minute_logged + mi) > minutes_per_file )
    {
      RadioTLog.close();
      RadioTLog = createWriter( main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt");    
      new_file_created =  main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt";      
      changed = true;
    }
  }
  else
  {
    RadioTLog.close();
    RadioTLog = createWriter( main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt");    
    new_file_created = main_dir + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".txt";
    changed = true;
  }
  
  if( changed == true )
  {
    last_day_logged = d;
    last_hour_logged = h;
    last_minute_logged = mi;    
    file_end = createWriter( main_dir + "end_of_file.eof" );
    file_end.print( last_file_created );
    file_end.flush();
    file_end.close();
    last_file_created = new_file_created;
    println(" NEW FILE ");
  }
  if( btLogger.stateValue() == 1 )
  {
    GetRTData();
  }
  
  
  
  //RTLSDR Stick ueberwachen, falls die Verstaerkung ausgeschaltet wurde
  boolean already_rebooted = WatchStickGainOff( );
 
  //RTLSDR Stick ueberwachen, falls er haengt
  //print("ZYCLE is");
  //println(watch_stick_iter);
  if( already_rebooted == false && --watch_stick_iter == 0 )
  {
    print("Watching is RTLSDR asleep....");
    log_info.print(WriteTimeStr() + "Watching is RTLSDR asleep....");
    delay(2000);
    WatchStickAsleep();
    watch_stick_iter = watch_stick_zycle;
  }
  
  if( cnt_read_baseline++ >=  read_baseline_iter )
  {
    println("Searching for Bseline File...");
    ReadBaseline( );
    //DeleteFile( gnuplot_dir + baseline_file_name );
    cnt_read_baseline = 0;
  }  
  
  if( do_1_after_arduino_alive == true )  
    Online_Whishes( );
  
  
  if( waiting_for_send == true && wished_alt_tosend > -1 )
  {
    if( getTimeInSec(true) - time_of_motor_start > TIME_TO_WAIT_FOR_MOTOR )
    {
      println("____________________________________SENDING NOW WISHED ALTITUD_____________________________");
      log_info.print(WriteTimeStr() + "  Sending now wished altitud");
      DoAfterMotorActivated();
      waiting_for_send = false;
      wished_alt_tosend = -1;
      time_of_motor_start = -1;
      if( motor_on_online == true )  //only if motor was activated via online, we want to shut it down again.
      {
        time_of_mess_sent = getTimeInSec(true); //we wait now for getting the wished alt and shutdown motor
        log_info.print("Motor was activated via ONLINE -> Setting TimeOfMessSent to " + WriteTimeStr() );
      }
    }
  }
 
 
  if( time_of_mess_sent > -1 )
  {
    if( getTimeInSec(true) - time_of_mess_sent > TIME_TO_WAIT_FOR_MOTOR )
    {
      if(motor_on_online == true && lastUP == false & lastDOWN == false)
       {
         println("____________________________________DEACTIVATING MOTOR AGAIN_____________________________");
         log_info.print(WriteTimeStr() + "  Deactivating motor again");
         if( motor_on_online == true )         
           DeactivateMotor();
         motor_on_online = false;
         time_of_mess_sent = -1;
         log_info.print("MotorOnline OUT TimeOfMessSent OUT");
       }
    }
  }
  
  /*
  drawAntenneMast();
  translate(-10, 40, 0);    
  lights();
  translate(antenne_x, antenne_y);  
  rotateY(radians(300-lastAZ));
  rotateZ( radians(-90+lastALT) );
  noStroke();
  fill(140, 160, 200);
  translate(0, -40, 0);
  drawCylinder(6, 40, 40, 64); // Draw a cylinder  
  */
  image(a, 120, 500, a.width, a.height);
   
  if( btOut.stateValue() == 0 )
  {
    AntennaSerial.stop();
    ObservSerial.stop();
    exit();
  }
  
  log_info.flush();
}

















/*******************************************************************************************************/
/*                                                                                                     */
/*                                     FUNCTION DEFINITIONS                                            */
/*                                                                                                     */
/*******************************************************************************************************/


/*******************************************************************************************************/
/*                                         HANDLES                                                     */
/*******************************************************************************************************/
void handleSliderEvents(GSlider slider) {
  println("integer value:" + slider.getValueI() + " float value:" + slider.getValueF());
}

public void handleButtonEvents(GButton button, GEvent event)
{
  if( button.tag == (String)"Stop" )
  {
       println("Sending Motor Stop");
       log_info.println(WriteTimeStr() + "Sending Motor Stop");
       AntennaSerial.write('s');  //info begin
       AntennaSerial.write('s');  //info begin
       AntennaSerial.write('s');  //info begin    
       AntennaSerial.write('S');
       AntennaSerial.write(0);       
       button.setLocalColorScheme(GCScheme.GREEN_SCHEME);
       delay(1000);
       button.setLocalColorScheme(GCScheme.BLUE_SCHEME);       
  }
  
  if( button.tag == (String)"Send" )
  {
     // controlP5.controller("Sent").setValue(1);
    println("");
    float sending_value = ConvertGradMinSecToDecimal( (int)sdrG.getValueI(),
                                     (int)sdrM.getValueI(),
                                     (int)sdrS.getValueI() );
    print("Sending float Value:  wished altitud is ");
    println( sending_value );  
    log_info.print(WriteTimeStr() + "Sending float Value:  wished altitud is ");
    log_info.println( sending_value );  
    SendToAntenna( sending_value, WISHED_ANGLE );
    button.setLocalColorScheme(GCScheme.GREEN_SCHEME);
    delay(1000);
    button.setLocalColorScheme(GCScheme.BLUE_SCHEME);
  }  
}

public void handleToggleButtonEvents(GImageToggleButton button, GEvent event) 
{ 
  println(button + "   State: " + button.stateValue() + button.tag);
  if( button.tag == (String)"Up" )
  {
    if( btDown.stateValue() == 1 )
      btDown.stateValue(0);
    if( button.stateValue() == 1 && lastUP != true)
     {
       print("Sending Motor Up with speed ");
       log_info.print(WriteTimeStr() + "Sending Motor Up with speed ");
       AntennaSerial.write('s');  //info begin
       AntennaSerial.write('s');  //info begin
       AntennaSerial.write('s');  //info begin    
       AntennaSerial.write('u');
       println((int)sdSpeed.getValueI());
       log_info.println((int)sdSpeed.getValueI());
       AntennaSerial.write((int)sdSpeed.getValueI());       
       delay(1000);
     }
  }
  if( button.tag == (String)"Down" )
  {
    if( btUp.stateValue() == 1 )
      btUp.stateValue(0);
    if( button.stateValue() == 1 && lastDOWN != true)
     {
       print("Sending Motor Down with speed ");
       log_info.print(WriteTimeStr() +  "Sending Motor Down with speed ");
       AntennaSerial.write('s');  //info begin
       AntennaSerial.write('s');  //info begin
       AntennaSerial.write('s');  //info begin    
       AntennaSerial.write('d');
       println((int)sdSpeed.getValueI());
       log_info.println((int)sdSpeed.getValueI());
       AntennaSerial.write((int)sdSpeed.getValueI());       
       delay(1000);
     }
  }
  if( button.tag == (String)"onoff" )
  {
    if( button.stateValue() == 1 )
    {
      log_info.println( WriteTimeStr() + "Acivating Antenna Motor");
      SendPleaseMotorControl( true );
    }      
    else    
    {
      SendPleaseMotorControl(false);
      log_info.println( WriteTimeStr() + "Deacivating Antenna Motor");
    }
  }
  
}


String ConvertFloatToGrad( float value, boolean altitud )
{
  String ret = "                        ";
  int grad = floor(value);  
  float tmp = (value - grad)*60;
  int grad_min = floor(tmp);
  float grad_sec = (tmp - grad_min) * 60;
  int i_grad_sec = (int)grad_sec;
  int i_grad_min = (int)grad_min;
  int i_grad = (int)grad;

  if( altitud == true )
    ret = Integer.toString(grad)+ "° " + Integer.toString(i_grad_min) + "' " + Integer.toString(i_grad_sec) + "''";  
  else
    ret = Integer.toString(grad)+ "° " + Integer.toString(i_grad_min) + "' " + Integer.toString(i_grad_sec) + "''";   
  return ret;
}

void ConvertFloatToGradMinSec( float value, boolean altitud )
{
  if( altitud == true )
  {
    last_g = floor(value);  
    float tmp = (value - last_g)*60;
    last_m = floor(tmp);
    last_s = int((tmp - last_m) * 60);     
  }
  else  //eqivalent to function Name ConverFloatToHourMinSec
  {
    last_az_h = floor(value);  
    float tmp = (value - last_az_h)*60;
    last_az_m = floor(tmp);
    last_az_s = int((tmp - last_az_m) * 60);    
  }
}

float ConvertGradMinSecToDecimal(int grad, int minutes, int seconds)
{
  return (((seconds/60.0)+minutes)/60.0)+grad;
}

void GetComData() 
{
  if( standalone == true || do_1_after_arduino_alive == false)
    return;
   
  /***************************************************************************************/
  /*                               Defined String for receiving                          */
  /* AZ,ALT,Tempearture,pressure,altitud,roll_10dof,pitch_10dof,alt_offset,down,up       */
  /* 0   1      2          3        4        5           6          7        8   9       */
  /***************************************************************************************/

  // read the serial buffer:
  String myString = AntennaSerial.readStringUntil(linefeed);

  boolean m_down = false, m_up = false;
  

  // if you got any bytes other than the linefeed:
  if (myString != null) {
    
    myString = trim(myString);

    // split the string at the commas
    // and convert the sections into integers:

    pSensors = sensors;
    sensors = float(split(myString, ','));
    
    
    if( sensors.length != numSensors )
    { 
        println("DATA ERROR 1");        
        return;                      
    }
    if( sensors[0] < 20.0 || sensors[0] > 360.0 || sensors[1] < 20.0 || sensors[1] > 90.0)
    { 
        println("DATA ERROR 2");
        return;                      
    }
    
    motorlog.println("");
    log_info.print("\t");
    for (int sensorNum = 0; sensorNum < sensors.length; sensorNum++) 
    {      
      if( sensorNum == 0)
      {
        print("AZ :" + sensors[sensorNum] + "\t");              
        motorlog.print("AZ " + sensors[sensorNum] + " ");
        log_info.print("AZ " + sensors[sensorNum]);
        lastAZ=sensors[sensorNum];        
      }
      if( sensorNum == 1)
      {
        print("ALT :"  + sensors[sensorNum] + "\t");                      
        motorlog.print("ALT " + sensors[sensorNum] );
        log_info.print("  ALT " + sensors[sensorNum]);
        lastALT=sensors[sensorNum];
        ConvertFloatToGradMinSec( lastALT, true );
      }
      if( sensorNum == 2)
      {
        print("TEMP :"  + sensors[sensorNum] + "°C\t");                      
        //motorlog.print("TEMP " + sensors[sensorNum] );
        log_info.print("  TEMP " + sensors[sensorNum]);
        lastTEMP=sensors[sensorNum];
        //ConvertFloatToGradMinSec( lastALT, true );
      }
      if( sensorNum == 4)
      {
        print("HIGH :"  + sensors[sensorNum] + "m\t");
        log_info.print("  HIGH " + sensors[sensorNum]);
        lastHIGH=sensors[sensorNum];
      }
      if( sensorNum == 5)
      {
        print("ROLL : "  + sensors[sensorNum] + "m\t");
        log_info.print("  ROLL " + sensors[sensorNum]);
        lastROLL=sensors[sensorNum];
      }      
      if( sensorNum == 6)
      {
        print("PITCH :"  + sensors[sensorNum] + "m\t");
        log_info.print("  PITCH " + sensors[sensorNum]);
        lastPITCH=sensors[sensorNum];
      }      
      if( sensorNum == 7)
      {
        print("ALT OFFSET :"  + sensors[sensorNum] + "m\t");
        log_info.print("  ALTOFFSET " + sensors[sensorNum]);
        lastOFFSET=sensors[sensorNum];
      }      
      if( sensorNum == 8)
      {
        float t_down = sensors[sensorNum];
        if( t_down < 1 )
        {
          m_down = false;
          lastDOWN = false;          
          print("NO DOWN\t");
          log_info.print("  ND ");
        }
        else
        {
          m_down = true;
          lastDOWN = true;
          print("DOWN\t");
          log_info.print("  D ");
        }
                    
        if( m_down )
        { 
          if( btDown.stateValue() == 0 )
            btDown.stateValue(1);         
        }
        else
        {          
          if( btDown.stateValue() == 1 )
          {
            btDown.stateValue(0);            
          }
        }
        
        
      }      
      if( sensorNum == 9)
      {
        float t_up = sensors[sensorNum];
        if( t_up < 1 )
        {
          m_up = false;
          lastUP = false;
          print("NO UP\t");
          log_info.print("  NU ");
        }
        else
        {
          lastUP = true;
          m_up = true;        
          print("UP\t");
          log_info.print("  U ");
        }       
        if( m_up )
        {  
          if( btUp.stateValue() == 0 )
            btUp.stateValue(1); 
        }
        else
        {          
          if( btUp.stateValue() == 1 )
          {
            btUp.stateValue(0);            
          }
        }
        
      }      
      motorlog.flush();
    }
    
    // add a linefeed after all the sensor values are printed:
    println();
    log_info.println();
  }
}




//DRAWING ANTENNA
void drawCylinder(float topRadius, float bottomRadius, float tall, int sides) {
  float angle = 0;
  float angleIncrement = TWO_PI / sides;
  beginShape(QUAD_STRIP);
  for (int i = 0; i < sides + 1; ++i) {
    vertex(bottomRadius*cos(angle),0 , bottomRadius*sin(angle));        
    vertex(topRadius*cos(angle), tall, topRadius*sin(angle));
    angle += angleIncrement;
  }
  endShape();
  // If it is not a cone, draw the circular top cap
  if (topRadius != 0) 
  {
    angle = 0;
    beginShape(TRIANGLE_FAN);
    
    // Center point
    vertex(0, 0, 0);
    for (int i = 0; i < sides + 1; i++) 
    {
      vertex(topRadius * cos(angle), tall, topRadius * sin(angle));
      angle += angleIncrement;
    }
    endShape();
  }

  // If it is not a cone, draw the circular bottom cap
  if (bottomRadius != 0) 
  {
    angle = 0;
    beginShape(TRIANGLE_FAN);

    // Center point
    vertex(0, tall, 0);
    for (int i = 0; i < sides + 1; i++) 
    {
      vertex(bottomRadius * cos(angle), 0, bottomRadius * sin(angle));
      angle += angleIncrement;
    }
    endShape();
  }
}

void drawAntenneMast( ) 
{  
  translate(trans_x_mast, trans_y_mast, 0);  
  fill(140, 160, 200);
  box(8,60,8);    
  int trans_y_fuss = 32;  
  translate(0,trans_y_fuss,0);
  drawCylinder(19, 4, 10, 4);  
  //translate(-310, -(trans_y_mast+trans_y_fuss), 0);       
  translate(-trans_x_mast, -(trans_y_mast+trans_y_fuss), 0);
}  



void SendToAntenna( float value, int info_type )
{
  if( standalone== true )
  {
    println("NOT SENDING. Standalone mode ON");
    log_info.println("NOT SENDING. Standalone mode ON");
    return;
  }
    
  int value_int_mul = int(value*100.0);
  int value_int = int(value);
  int value_mod = value_int_mul % 100;
  while( true )
  {
    if (AntennaSerial.available() > 0 ) 
    {
     if( info_type == WISHED_ANGLE )
     {
      println("Sending desire Angle ");
      print("INT Part is ");
      print(value_int);
      print("     DEC Part is ");
      println(value_mod);
      println("FULL Value is ");
      println(value);    
      log_info.print(WriteTimeStr() + "Sending desire Angle ");log_info.println(value);
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin    
      AntennaSerial.write(value_int);
      AntennaSerial.write(value_mod);
      return;
     }
     else if( info_type == MOTOR_UP )
     {
      println("Sending motor up ");
      print("with speed ");
      print(value_int);
      println(value);    
      log_info.print(WriteTimeStr() + "Sending motor up");
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin    
      AntennaSerial.write('u');
      AntennaSerial.write(value_int);
      return;       
     }
     else if( info_type == MOTOR_DOWN )
     {
      println("Sending motor down ");
      print("with speed ");
      print(value_int);
      println(value);    
      log_info.print(WriteTimeStr() + "Sending motor down ");
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin    
      AntennaSerial.write('d');
      AntennaSerial.write(value_int);
      return;       
     }
     else if( info_type == MOTOR_STOP )
     {
      println("Sending stop motor");
      log_info.print(WriteTimeStr() + "Sending stop motor");
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin
      AntennaSerial.write('s');  //info begin    
      AntennaSerial.write('S');
      return;       
     }     
    }
    
  }
}


void ResetBaselineValues( )
{
  if(standalone == true )
    return;
  while( true )
  {
    if (ObservSerial.available() > 0 ) 
   {
      println("Sending Reset Baseline Values to Arduino!! ");      
      log_info.println(" Sending Reset Baseline Values to Arduino");
      ObservSerial.write('B');  //reset volts 
      return;
    }
  }
}


int canal_pos_v = 6;
int canal_neg_v = 7;
int canal_read4725 = 8;
int canal_total_power = 5;  //Total power  //signal generated with the mcp4725 as a temperature compensated signal
int canal_ad8307_mod = 0; 
int canal_mag_x = 9;
int canal_mag_y = canal_mag_x+1;
int canal_mag_z = canal_mag_y+1;


void GetRTData() 
{
  if( standalone == true )
    return;
  // read the serial buffer:
  String myString = ObservSerial.readStringUntil(linefeed);

  int d = day();    // Values from 1 - 31
  String d_mod = (( d < 10)?"0":"") + String.valueOf(d);
  int m = month();  // Values from 1 - 12
  String m_mod = (( m < 10)?"0":"") + String.valueOf(m); //String.valueOf(m)
  int y = year();   // 2003, 2004, 2005, etc.
  int h = hour();    // Values from 1 - 31
  String h_mod = (( h < 10)?"0":"") + String.valueOf(h);
  int mi = minute();  // Values from 1 - 12
  String mi_mod = (( mi < 10)?"0":"") + String.valueOf(mi);
  int se = second();   // 2003, 2004, 2005, etc.
  String se_mod = (( se < 10)?"0":"") + String.valueOf(se);
  

  
  // if you got any bytes other than the linefeed:
  if (myString != null) 
  {
    if( do_1_after_arduino_alive == false )
    {
      do_1_after_arduino_alive = true;
      DeactivateMotor();
    }
    
    myString = trim(myString);
    //no_data_alarm = false;

    // split the string at the commas
    // and convert the sections into integers:

    pRTSensors = rt_sensors;
    rt_sensors = float(split(myString, ','));
    DecimalFormat df = new DecimalFormat("0.###");



  
    if( start_writting == true )
    {
    // print out the values you got:
      int sensorNum = 0;
      int wroten_values = 0;
      //float saved_values[];
      boolean values_ok = true;
      if( rt_sensors.length != numRTSensors+1 )
      { 
        values_ok = false;                      
      } 
      else    
      {
        if( rt_sensors.length > 0 && rt_sensors[0] == 8.8 )   //DATA RECEIVED
        {
          //println("Received DATA from RT. Preparate Data...."); 
          for (sensorNum = 0; sensorNum < rt_sensors.length-1; sensorNum++) 
          {  
            //print(sensorNum);print(" "); print(rt_sensors[sensorNum]);print(" ");
            rt_sensors[sensorNum] = rt_sensors[sensorNum+1];
            //print("now ");println(rt_sensors[sensorNum]);
            if( sensorNum < canal_mag_x )
            {            
              rt_sensors[sensorNum] = rt_sensors[sensorNum]/1000;
              if( rt_sensors[sensorNum] < 0.0  || rt_sensors[sensorNum] > 5.0 )
                values_ok = false;
            }
          }
          //println("DONE");
        }
      }
      if( values_ok == false )
      {
        if( rt_sensors.length == 1 )
        {
          if( rt_sensors[0] == 1.1 )  //ACTIVATING MOTOR
          {
            println("Received ACTIVATED MOTOR via BT");
            DisplayMotorON();
          }
          else if( rt_sensors[0] == 2.2) //DEACTIVATING MOTOR
          { 
            println("Received DEACTIVATED MOTOR via BT");  
            DisplayMotorOFF( );        
          }
        }
        else
          println("DATA ERROR 3");
        //delay(1000);
        return;
      }
      stroke(204, 102, 0);
  fill(160);
  rect(stripchar_text_x, 20, 60, 220);
  fill(0);
  textSize(12);
    //textFont(f,12);  
  fill(160);
  rect(stripchar_text_x, 760, 60, 80);
  fill(0);
      for (sensorNum = 0; sensorNum < rt_sensors.length-1; sensorNum++) 
      {      
        //print("Reading element "); print(sensorNum); print("  ");
        if( rt_sensors[sensorNum] <= 0)
          rt_sensors[sensorNum] = 0.001;
          
        //if( rt_sensors[sensorNum] >= 0 && rt_sensors[sensorNum] < 6 && wroten_values < numRTSensors)
        {
          if( sensorNum == 1 )
            rt_sensors[sensorNum] = rt_sensors[sensorNum]*2;
          RadioTLog.print(rt_sensors[sensorNum] + "\t");
          print(rt_sensors[sensorNum] + "\t");

          if( sensorNum < canal_mag_x )
            s3.addData(sensorNum, rt_sensors[sensorNum]);
          else           
            s_mag.addData(sensorNum-canal_mag_x, rt_sensors[sensorNum]);
        
          
          if( sensorNum == canal_pos_v )
            s1.addData(0, rt_sensors[sensorNum]);
          else if( sensorNum == canal_neg_v )
            s1.addData(1, rt_sensors[sensorNum]);
          else if( sensorNum == canal_read4725 )
            s1.addData(2, rt_sensors[sensorNum]);
          else if( sensorNum == canal_total_power )
            s2.addData(0, rt_sensors[sensorNum]); 
          else if( sensorNum == canal_ad8307_mod )
            s2.addData(1, rt_sensors[sensorNum]);
          
          
          String c_val = df.format( rt_sensors[sensorNum] ) ;
          if( sensorNum < canal_mag_x )
            text(c_val, stripchar_text_x+10,40 + (sensorNum*20)); 
          else
            text(c_val,stripchar_text_x+10,785 + ((sensorNum-canal_mag_x)*20)); 
        }
      }
      
      //String baseline_val = df.format( last_baseline_done ) ;
      String baseline_val = df.format( last_baseline_received ) ;      
      RadioTLog.print(last_baseline_received + "\t");
      print(last_baseline_done + "\t");      
      text(baseline_val,stripchar_text_x+10,40 + (s3_fields*20) + 10); 
      //if( numRTSensors == wroten_values )
      {
        s3.display();
        s2.display();
        s1.display();
        s_mag.display();
        
        print(h_mod + ":" + mi_mod + ":" + se_mod + "\t" );
        RadioTLog.print(h_mod + ":" + mi_mod + ":" + se_mod + "\t" );
        print(d_mod + "." + m_mod + "." + String.valueOf(y) );
        RadioTLog.print(d_mod + "." + m_mod + "." + String.valueOf(y) );
        // add a linefeed after all the sensor values are printed:
        println("");
        RadioTLog.println("");
        RadioTLog.flush();
      }
    }
    else 
    {
      ignore_num--;
      if( ignore_num == 0 )
        start_writting = true;
    }
  }
 
}


boolean WatchStickGainOff( )
{
  int d  = day();    // Values from 1 - 31
  int h  = hour();    // Values from 1 - 31
  int mi = minute();  // Values from 1 - 12
  int m = month();  // Values from 1 - 12
  int y = year();   // 2003, 2004, 2005, etc.
  int se = second();   // 2003, 2004, 2005, etc.  
  
  String d_mod = (( d < 10)?"0":"") + String.valueOf(d);        
  String m_mod = (( m < 10)?"0":"") + String.valueOf(m); //String.valueOf(m)                
  String h_mod = (( h < 10)?"0":"") + String.valueOf(h);        
  String mi_mod = (( mi < 10)?"0":"") + String.valueOf(mi);       
  String se_mod = (( se < 10)?"0":"") + String.valueOf(se);    
  
  String fileName = dataPath(gnuplot_dir + "ErrorScan.err");
  File f = new File(fileName);
  if (f.exists()) {
    println("FILE FOUND          FILE FOUND");
    log_info.println(d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ": File ErrorScan found. Stick muss be rebooted");
    delay(100);
    SendPleaseReboot();
    delay(1000);
    f.delete();
    PrintWriter log_reboot;
    log_reboot = createWriter( main_dir + "RebootetInfos\\rebooted_" + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".err");
    log_reboot.close();
    return (true);
  }
  return (false);
}  

void ReadAntennePosition( )
{
  File f = new File(gnuplot_dir + alt_az_filename);
  if (f.exists() == false ) 
  {
    return;
  }
  
  BufferedReader antenna_pos = createReader(gnuplot_dir + alt_az_filename); 
  while(true)
  {
  try {
      line = antenna_pos.readLine();
    } catch (IOException e) 
    {
      e.printStackTrace();
      line = null;
      return;
    }
    if (line == null) 
    {      
      return;
    } 
    else 
    {
      if( line.length() > 0  )
      {        
        String[] pieces = split(line, ' ');
                
        println("Reading AZ_ALT text file...");        
        log_info.println("Reading AZALT text file...");
        if( pieces[0].length() > 0 && pieces[0].equals("AZ") &&  pieces[2].length() >0 && pieces[2].equals("ALT"))
        {
          print("AZ is ");
          log_info.print("AZ ");
          delay(10);
          if( pieces[1].length() > 0 )
          {
            lastAZ = float(pieces[1]);
            print( lastAZ );
            log_info.print( lastAZ );
          }
          print("  ALT is ");
          log_info.print("  ALT ");
          delay(10);
          if( pieces[3].length() > 0 )
          {
            lastALT = float(pieces[3]);
            println( lastALT );
            log_info.println(lastALT );
          }          
        }
      }
    }
    
  }//end while(1)  
}

void ReadSwitchOnOff()
{
  BufferedReader switch_on_off = createReader(dropbox_dir + switch_on_filename);    
  try 
  {
    line = switch_on_off.readLine();
    switch_on_off.close();
  } 
  catch (IOException e) 
  {
      e.printStackTrace();
      line = null;
      return;
  }
    if (line == null) 
    {    
      return;
    } 
    else 
    {
      if( line.length() > 0  )
      {        
        String[] pieces = split(line, ' ');
        println("Reading Switch On or Off wish...");
        log_info.println(WriteTimeStr() + "Reading Switch On or Off wish.."); 
        if( pieces[0].length() >0 && pieces[0].equals("ON"))
        {
          log_info.println(WriteTimeStr() + "Activating Only"); 
          ActivateMotor( true, -1 ); //activation mode is "simple"
          File g = new File(dropbox_dir + motor_off_filename);
          if( g.exists() )
            g.delete();
          PrintWriter feedback_file = createWriter( dropbox_dir + motor_on_filename );          
        }
        if( pieces[0].length() >0 && pieces[0].equals("OFF"))
        {
          log_info.println(WriteTimeStr() + "Deactivating Only"); 
          DeactivateMotor( );
          File g = new File(dropbox_dir + motor_on_filename);
          if( g.exists() )
            g.delete();          
          PrintWriter feedback_file = createWriter( dropbox_dir + motor_off_filename );          
        }
      }
    }

}


void ReadWishedALT()
{  
  BufferedReader wished_pos = createReader(dropbox_dir + online_alt_filename);    
  try 
  {
    line = wished_pos.readLine();
    wished_pos.close();
  } 
  catch (IOException e) 
  {
      e.printStackTrace();
      line = null;
      return;
  }
    if (line == null) 
    {    
      return;
    } 
    else 
    {
      if( line.length() > 0  )
      {        
        String[] pieces = split(line, ' ');
                
        println("Reading online wished ALT...");
        log_info.println(WriteTimeStr() + "Reading online wished ALT..."); 
        if( pieces[0].length() >0 && pieces[0].equals("ALT"))
        {
          print("Wished ALT is ");
          log_info.print("Wished ALT is ");
          if( pieces.length == 2 && pieces[1].length() > 0 )             //ex. ALT 80.2 
          {             
            float wishedALT = float(pieces[1]);
            println( wishedALT );
            log_info.println( wishedALT );
            if( wishedALT < 0 || wishedALT > 90.0 )
              return;
            motor_on_online = true;
            log_info.println( "MotorOnline ON");
            ActivateMotor( false, -1 );
            wished_alt_tosend = wishedALT;
          }
          else if( pieces[0].equals("ALT") )                                
          {
            println("TIME OR DIFF?");
            if( pieces[1].equals("+") || pieces[1].equals("-"))             //ALT + 2   o   ALT - 2
            {
              println("DIFF");
              float wishedDiffALT = float(pieces[2]);
              float wishedALT = -1.0;
              if( pieces[1].equals("+") )
                wishedALT = lastALT + wishedDiffALT;
              else 
                wishedALT = lastALT - wishedDiffALT;
              println( wishedALT );
              log_info.print( wishedALT ); log_info.print(" Diff " +  pieces[1] + " ");log_info.println(wishedDiffALT); 
              if( wishedALT < 0 || wishedALT > 90.0 )
                return;
              motor_on_online = true;
              log_info.println( "MotorOnline ON");
              ActivateMotor( false, -1 );
              wished_alt_tosend = wishedALT;              
            }
            else                                                             //ALT 80.3 14:22:00
            {
              println("TIME");
              String[] time_values = split(pieces[2], ':');
              int wished_hour = int(time_values[0]);
              int wished_min = int(time_values[1]);
              int wished_sec = int(time_values[2]);
              if( wished_hour<0 || wished_hour>23 ||  wished_min<0 || wished_min>59 || wished_sec<0 || wished_sec>59 )
              {
                log_info.println("ERROR in TIME FORMAT");
                return;
              }
              float wishedALT = float(pieces[1]);
              print( wishedALT ); print(" at ");println(pieces[2]);
              log_info.print( wishedALT ); log_info.print(" at "); log_info.println(pieces[2]);
              if( wishedALT < 0 || wishedALT > 90.0 )
                return;
              motor_on_online = true;              
              long time_untill_start = (long)(wished_hour*3600 + wished_min*60 + wished_sec) - getTimeInSec(false) ;
              log_info.println( "MotorOnline ON");
              ActivateMotor( false, time_untill_start );
              wished_alt_tosend = wishedALT;                
            }           
          }
          
        }
      }      
    }  
  return;
}

void DoAfterMotorActivated()
{
  print("______________________________");
  log_info.println(WriteTimeStr() + "After having activated the Motor...");
  SendToAntenna( wished_alt_tosend, WISHED_ANGLE );
  delay(1000);
  wished_alt_tosend = -1;
  PrintWriter feedback_file = createWriter( dropbox_dir + "SetALT_done.txt" );
  feedback_file.print("ALT set on ");feedback_file.println(wished_alt_tosend);    
  feedback_file.flush();
  feedback_file.close();                       
}

void Online_Whishes ( )
{   
  File f = new File(dropbox_dir + online_alt_filename);
  File g = new File(dropbox_dir + switch_on_filename);

  if (g.exists()) 
  {
    log_info.println(WriteTimeStr() + "SwitchOn FILE exists!!");
    ReadSwitchOnOff( );
    print("Deleting file "); println(dropbox_dir + switch_on_filename);
    g.delete();
  }

  if (f.exists()) 
  {
    log_info.println(WriteTimeStr() + "ONLINE wished ALT FILE exists!!");
    ReadWishedALT( );
    print("Deleting file "); println(dropbox_dir + online_alt_filename);
    f.delete();
  }
  return;
}

void WatchStickAsleep( )
{
   int d  = day();    // Values from 1 - 31
   int h  = hour();    // Values from 1 - 31
   int mi = minute();  // Values from 1 - 12
   int m = month();  // Values from 1 - 12
   int y = year();   // 2003, 2004, 2005, etc.
   int se = second();   // 2003, 2004, 2005, etc.  
   
   boolean need_reboot = false;
   
    reader = createReader(scanner_dir + "Last_Scan.info");  
    try {
      line = reader.readLine();
    } catch (IOException e) {
      e.printStackTrace();
      line = null;
    }
    if (line == null) {
      // Stop reading because of an error or file is empty
      noLoop();  
    } 
    else 
    {
      if( line.length() > 2  )
      {        
        String[] pieces = split(line, ' ');
        String[] date_pieces = split(pieces[0], '.');    //getting date
        int fd = int(date_pieces[0]);
        int fm = int(date_pieces[1]);
        int fy = int(date_pieces[2]);
        int fh = 0;
        int fmi = 0;
      
        if( pieces[1].length() == 0)
        {
          println("PIECES 2");
          delay(1000);
          String[] time_pieces = split(pieces[2], ':');  //getting time
          fh = int(time_pieces[0]);
          fmi = int(time_pieces[1]);
        }
        else
        {
          println("PIECES 1");
          delay(1000);
          String[] time_pieces = split(pieces[1], ':');  //getting time
          fh = int(time_pieces[0]);
          fmi = int(time_pieces[1]);          
        }
        //int fh = int(time_pieces[0]);
        //print(time_pieces[1]);
        //int fmi = int(time_pieces[1]);
        if( m == fm && y == fy )
        {
          if( d == fd  )
          {
            if(  h == fh && (m - fm) > 10 )
              need_reboot = true;
            else if( h != fh && (60-fmi+m) > 10 )
              need_reboot = true;
          }
          else if( d != fd )
          {
            if( 23-fh+h == 0 && (60-fmi+m)>10 )
              need_reboot = true;
          }
        }
        else 
          need_reboot = true;                  
        
        if( need_reboot == true )
        {
          String d_mod = (( d < 10)?"0":"") + String.valueOf(d);        
          String m_mod = (( m < 10)?"0":"") + String.valueOf(m); //String.valueOf(m)                
          String h_mod = (( h < 10)?"0":"") + String.valueOf(h);        
          String mi_mod = (( mi < 10)?"0":"") + String.valueOf(mi);  
          String se_mod = (( se < 10)?"0":"") + String.valueOf(se);           
          SendPleaseReboot();
          PrintWriter log_reboot;
          log_reboot = createWriter( main_dir + "RebootetInfos\\rebooted_" + d_mod + "." + m_mod + "." + String.valueOf(y) + "_" + h_mod + "-" + mi_mod + "-" + se_mod + ".err");
          String writting_Str = "rebooting due to file " + line + " " + "real date " + m + " " + d + " " + y + " and time " + h + " " + m;
          println( writting_Str );
          log_reboot.println(writting_Str); 
          log_reboot.flush();
          log_reboot.close();
          println("YES");
          delay( 2000 );
          last_scan_time = line;
        }
        
      }
    }
}

String WriteTimeStr( )
{
  int h = hour();    // Values from 1 - 31
  String h_mod = (( h < 10)?"0":"") + String.valueOf(h);
  int mi = minute();  // Values from 1 - 12
  String mi_mod = (( mi < 10)?"0":"") + String.valueOf(mi);
  int se = second();   // 2003, 2004, 2005, etc.
  String se_mod = (( se < 10)?"0":"") + String.valueOf(se);
  return( h_mod + ":" + mi_mod + ":" + se_mod + "\t" );
}

void ReadBaseline()
{
  File bf = new File(gnuplot_dir + block_while_writting); 
  if( bf.exists() ) //while file lives, do not read baseline file
    return ;
    
  boolean done = false;  
  String fileName = dataPath(gnuplot_dir + baseline_file_name);
  File f = new File(gnuplot_dir + baseline_file_name); 
  if( !f.exists() )
    return ;
  
  BufferedReader baseline_reader = createReader(fileName);  
    try {
      line = baseline_reader.readLine();
    } catch (IOException e) {
      e.printStackTrace();
      line = null;
    }
    if (line == null) 
    {
      noLoop();  
    } 
    else 
    {
      if( line.length() > 2  )
      {        
        String[] pieces = split(line, ' ');
        float baseline_read = float(pieces[0]);
        int time_file = int(pieces[1]);
        float total_power = float(pieces[2]);
        
        
        if( mode == MODE_BASELINE && 
            baseline_read == last_baseline_done && time_file==time_last_baseline)
              return;
        
        
        if( mode == MODE_TOTAL_POWER )
        {
          if( total_power != last_total_power_sent )
          {
            log_info.print( WriteTimeStr() );
            log_info.print(baseline_read);log_info.print("dB   ");
            log_info.print(time_file);log_info.print(" sec   ");
            log_info.print(total_power);log_info.println(" ETP");
          }
          
          if( last_total_power_sent <= 0.0 )
          {
            last_total_power_sent = total_power;
            SendTotalPower( total_power*1000 );
            println("Setting Total Power value the first time");
            log_info.println(WriteTimeStr() + "Total Power Value set for the first time");
          }
          else if( abs( total_power - last_total_power_sent ) > 0 )
          {
            if( total_power > 0.0 )
            {
              SendTotalPower( total_power*1000 ); 
              last_total_power_sent = total_power;
            }
            else 
            {
              log_info.print(WriteTimeStr() + "Total Power Value Ignored: ");
              log_info.print(total_power); log_info.print(" Last Total Power Sent: ");
              log_info.println(last_total_power_sent);
            }
          }
          else
          {
            if( abs( total_power - last_total_power_sent ) > 0 )
            {
              log_info.print(WriteTimeStr() + "Last Total Power received: ");
              log_info.print(last_total_power_sent);
              log_info.print("    Diff: ");
              log_info.println(abs( total_power - last_total_power_sent ));
              print("Last Total Power received: ");print(last_total_power_sent);
              print("    Diff: ");
              println( abs( total_power - last_total_power_sent ) );   
            }         
          }
        }
        
        
        //if( mode == MODE_BASELINE )
        {
              
          if(( last_baseline_done > 0.0 ) ||
             ( last_baseline_done < 0.0 &&  (time_file-time_last_baseline) > time_offset_ok) ||
             ( last_baseline_done < 0.0 &&  abs(last_baseline_done-baseline_read) > baseline_offset_ok))
          {
            print("Baseline in File: ");print(baseline_read);print("   Time: ");println(time_file);
            log_info.println("Reading Baseline -> Nothing done");

            //initialize
            for(int b_index=0;b_index<BASELINE_MESSURES;b_index++)
               baseline_mess[b_index]=baseline_read;
         
            if(  last_baseline_done < 0.0 &&  (time_file-time_last_baseline) > time_offset_ok)
            {
              log_info.print("Filetime too old: ");log_info.println(time_file-time_last_baseline);
            }
           else if( last_baseline_done < 0.0 &&  abs(last_baseline_done-baseline_read) > baseline_offset_ok)
           {
              log_info.print("Baseline in file too different: ");log_info.println(last_baseline_done-baseline_read);                  
            }
            last_baseline_received = baseline_read;
            last_baseline_done = baseline_read;
            time_last_baseline = time_file;
            log_info.print(WriteTimeStr() + "Setting new Values  ---->   Last baseline ");log_info.print(last_baseline_done);
            log_info.print("   Last time: ");log_info.println(time_last_baseline);   
          }
          else 
          {     
            float baseline_mean_value = 0.0;
            baseline_mess[cnt_baseline_messure++]=baseline_read;
            if( cnt_baseline_messure == BASELINE_MESSURES )
              cnt_baseline_messure = 0;
            //get mean value  
            for(int b_index=0;b_index<BASELINE_MESSURES;b_index++)
              baseline_mean_value += baseline_mess[b_index];
            baseline_mean_value /= BASELINE_MESSURES;  
            
            float diff = baseline_mean_value-last_baseline_done;
            if( abs(diff) > 0.01 )
            {
              print("Last baseline ");print(last_baseline_done);print("   Last time: ");println(time_last_baseline);
              log_info.print(WriteTimeStr() + "Last baseline ");log_info.print(last_baseline_done);
              log_info.print("   Last time: ");log_info.print(time_last_baseline);          
              print("Baseline in File: ");print(baseline_read);print("   Time: ");println(time_file);
              print("Baseline Mean Value: ");print(baseline_mean_value);
            //float diff = baseline_read-last_baseline_done; 
             
              log_info.print("    dB Diff: ");log_info.println(Float.toString(diff));
            }
          
            if( diff >= baseline_offset )
            {
              log_info.println("Diff greater than offset. Sending less volts");
              int cnt = (int)((abs(diff))/baseline_offset);
              if( mode == MODE_BASELINE )
              {
                for(int j=0; j<cnt; j++)
                  SendBaselineAction( true );         
              }
              done = true;   
            }
            else if( diff <= (-baseline_offset) )
            {
              log_info.println("Diff greater than offset. Sending more volts");            
              int cnt = (int)((abs(diff))/baseline_offset);
              if( mode == MODE_BASELINE )
              {
                for(int j=0; j<cnt; j++)
                  SendBaselineAction( false );   
              }
              done= true;
            }       
            if(done == true)
            {
              last_baseline_done = baseline_read;
              time_last_baseline = time_file;   
            }
            last_baseline_received = baseline_read;  
          }
        }//Ende MODE_BASELINE
        
               
        
      }
    }          
    log_info.println("");
}


void SendPleaseReboot(  )
{
  if( standalone == true )
   return;
  while( true )
  {
    if (ObservSerial.available() > 0 ) 
   {
      println("Sending Please Reboot to Arduino ");
      log_info.println(WriteTimeStr() + "Sending Please Reboot to Arduino ");
      ObservSerial.write('R');  //info begin
      return;
    }
  }
}

void SendTotalPower( float value )  //Example  238.54
{
  if( standalone == true )
   return;
  value = value + 200.0;
  int cent_value = (int)(value/100.0);  //  2
  float dec_value = value - (cent_value*100.0); //  38.54
  int value_int_mul = int(dec_value*100.0);  // 3854
  int value_int = int(dec_value);  // 38
  int value_mod = value_int_mul % 100;  // 54
  while( true )
  {
    if (ObservSerial.available() > 0 ) 
    {
       println("Sending Total Power ");
       print("CENT Part is "); print(cent_value);
       print("     INT Part is "); print(value_int);
       print("     DEC Part is ");  print(value_mod);
       print("     FULL Value is "); println(value);    
       ObservSerial.write('T');  //info begin
       ObservSerial.write(cent_value);  //2
       ObservSerial.write(value_int);   //38 
       ObservSerial.write(value_mod);   //54
       log_info.print(WriteTimeStr() + "TP Sent:"); log_info.println(value); 
       //delay(100);
       return;
    }
  }
}

void SendBaselineAction( boolean more )
{
  if( standalone == true )
   return;
  while( true )
  {
    if (ObservSerial.available() > 0 ) 
   {
      print("Sending ActionItem for Temperature Compensation to Arduino: ");
      if( more == true )
      {
        println(" Baseline Push Up");
        log_info.println(" Baseline Push Up");
        ObservSerial.write('M');  //more volts 
      }
      else
      {
        ObservSerial.write('L');  //less volts
        log_info.println(" Baseline Push Down");        
        println(" Baseline Push Down");
      }
      return;
    }
  }
}

void DisplayMotorON( )
{
  println("Motor was avtivated via BT. Setting display to ON");
  log_info.println(WriteTimeStr() + "Motor was avtivated via BT. Setting display to ON");
  if( last_sent_motorONOFF == true )
  {
    println("Motor was already ON");
    log_info.println("Motor was already ON");
    return;
  }   
  last_sent_motorONOFF = true;
  btONOFF.stateValue( 1 );
  println("DONE");  
}

void DisplayMotorOFF( )
{
  println("Motor was deavtivated via BT. Setting display to OFF!");
  log_info.println(WriteTimeStr() + "Motor was deavtivated via BT. Setting display to OFF!");
  if( last_sent_motorONOFF == false )
  {
    println("Motor was already OFF");
    log_info.println("Motor was already OFF");
    return;
  }
  last_sent_motorONOFF = false;
  btONOFF.stateValue( 0 );
  println("DONE");
  return;
}


void ActivateMotor( boolean simple, long wished_start_time )
{
  println("_____________________________Activating Motor...");
  log_info.println(WriteTimeStr() + "Activating Motor");
  
  if( simple == true )
  {
    if( last_sent_motorONOFF == true )  //motor was sometime already activated
    {
      println("Motor was already ON");
      log_info.println("Motor was already ON. Exiting");
      return;
    }
    log_info.println("Activating Only");
    last_sent_motorONOFF = true;
    SendPleaseMotorControl( true );
    btONOFF.stateValue( 1 );
    return;
  }
  
  if( last_sent_motorONOFF == true && wished_start_time < 0 )  //motor was sometime already activated
  {
    println("Motor was already ON");
    log_info.println("Motor was already ON. Now waiting for sending 5 sec");
    waiting_for_send = true;
    time_of_motor_start = getTimeInSec(true) - TIME_TO_WAIT_FOR_MOTOR+5;
    return;
  }   
  last_sent_motorONOFF = true;
  SendPleaseMotorControl( true );
  btONOFF.stateValue( 1 );

  waiting_for_send = true;
  if( wished_start_time < 0 )
  {
    print("Waiting now "); print(TIME_TO_WAIT_FOR_MOTOR); println(" sec for Motor Start");  
    log_info.print("Waiting now "); log_info.print(TIME_TO_WAIT_FOR_MOTOR); log_info.println(" sec for Motor Start");
    time_of_motor_start = getTimeInSec(true);
  }
  else
  {
    print("Wished StartTime. Waiting now "); print(wished_start_time -  TIME_TO_WAIT_FOR_MOTOR); println(" sec for Motor Start");  
    log_info.print("Wished StartTime. Waiting now "); log_info.print(wished_start_time -  TIME_TO_WAIT_FOR_MOTOR); log_info.println(" sec for Motor Start");
    time_of_motor_start = getTimeInSec(true) + wished_start_time -  TIME_TO_WAIT_FOR_MOTOR;
  }
}


void DeactivateMotor( )
{
  println("Deactivating Motor!");
  log_info.println(WriteTimeStr() + "Deactivating Motor!");
  if( last_sent_motorONOFF == false )
  {
    println("Motor was already OFF");
    log_info.println("Motor was already OFF");
    return;
  }
  last_sent_motorONOFF = false;
  SendPleaseMotorControl( false );
  btONOFF.stateValue( 0 );
}

void SendPleaseMotorControl( boolean on_off )
{
  if(standalone == true )
  {
    log_info.println("No Activation. Standalone Mode");
    return;
  }
    
  while( true )
  {
    if (ObservSerial.available() > 0 ) 
   {
      last_sent_motorONOFF = on_off;
      print("Sending Please Switch MotorControll to Arduino ");
      log_info.print(WriteTimeStr() + "Sending Please Switch MotorControll to Arduino");
      if( on_off == true )
      {
        println(" to switch on");
        log_info.println(" to switch on");
        ObservSerial.write('Y');          
      }
      else
      {
        println(" to switch off");
        log_info.println(" to switch off");
        ObservSerial.write('X');          
      }
      return;
    }
  }
}


long getTimeInSec( boolean utc )
{
  if( utc == true )
    calender = Calendar.getInstance(TimeZone.getTimeZone("UTC"));
  else
    calender = Calendar.getInstance(Locale.getDefault());
  //println(calender.get(Calendar.HOUR_OF_DAY)*3600+calender.get(Calendar.MINUTE)*60+calender.get(Calendar.SECOND));
  return(calender.get(Calendar.HOUR_OF_DAY)*3600+calender.get(Calendar.MINUTE)*60+calender.get(Calendar.SECOND));
}


